/* Process model C form file: ip_gwy.pr.c */
/* Portions of this file Copyright (C) MIL 3, Inc. 1992 */



/* OPNET system definitions */
#include <opnet.h>
#include "ip_gwy.pr.h"
FSM_EXT_DECS



/* Header block */
#include "ip_frag_sup.h"
/* Macros Used to Represent Transitions. */
#define QUEUE_EMPTY     	(op_q_empty ())
#define SVC_COMPLETION  	((op_intrpt_type () == OPC_INTRPT_SELF) && (op_intrpt_code () == 0))
#define ARRIVAL         	op_intrpt_type () == OPC_INTRPT_STRM
#define END_SIM				op_intrpt_type () == OPC_INTRPT_ENDSIM

#define MAC_UPD_OUTSTAT		0
#define THRU_OUT 			1
#define THROUGHPUT			2
#define CUMM_THRU 			3
#define BIT_THRU 			4
#define CUMM_BIT_THRU 		5
#define Lsa_Vs_Other_Stat	6

#define ON						1
#define OFF 					0
#define BUSY					1
#define IDLE 					0
#define TRUE					1
#define FALSE 					0

#define RSVP_STREAM 			14
#define QOSPF_STREAM 			13
#define IGMP_STREAM				12
#define TCP_STREAM				11

#define VL if(ON)
#define IPVL if(OFF)

#define InLIST_SIZE 			10

#define MAX_NO_LINKS 			10
#define MAX_NO_GRPS 			50

#define IS_MULTICAST			500
#define ALL_SPF_ROUTER_NET		400
#define ALL_SPF_ROUTER_NODE		5
#define ALL_D_ROUTER_NET		400
#define ALL_D_ROUTER_NODE		6

#define DEF_STREAM				110

#define CONTROL_PKTS			0
#define BE_PKTS					1
#define RESV_PKTS				2

#define MAX_LEN_CONTROL_BUFFER	20
#define MAX_LEN_RESV_BUFFER		40
#define MAX_LEN_BE_BUFFER		40

#define IGMP_PROTOCOL_ID		9
#define TCP_PROTOCOL_ID			12
#define UDP_PROTOCOL_ID			20
#define RSVP_PROTOCOL_ID		46
#define QOSPF_PROTOCOL_ID		89

#define IP_DEFAULT_TTL			32

struct MC
{  int interface[MAX_NO_LINKS];
   int mtu[MAX_NO_LINKS];
};
typedef struct MC mc_id;

/*
** IP Address structure
*/
typedef struct {
	int NetNum;
	int NodeNum;
} IPAddress;

/*
** Session Directory Structure
*/
typedef struct {
    IPAddress SenderAddr;
    IPAddress DestAddr;
    int SenderPort;
    double Bandwidth;
    double Delay;
}sd;
 
/*
** Function Prototypes that are being used in this module
*/
 
int get_prio();
int CheckIfResvPkt( int, int, int, int );



/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	int                     		sv_server_busy;
	int                     		sv_rte_tab[501];
	int                     		sv_gwy_type;
	int                     		sv_Indep_Rou;
	int                     		sv_mc_join[100][100];
	double                  		sv_pk_sent;
	double                  		sv_tmpPkSent;
	double                  		sv_sizeofpacket;
	double                  		sv_tmpsizeofpacket;
	double                  		sv_service_rate;
	double                  		sv_tmp_sim_time;
	double                  		sv_tmp_sim_time1;
	double                  		sv_tracking_interval;
	double                  		sv_ControlPktBitsSer;
	Objid                   		sv_own_id;
	Objid                   		sv_sub_netid;
	Objid                   		sv_qospf_objid;
	Objid                   		sv_rsvp_objid;
	int	                    		sv_net_num0;
	int	                    		sv_node_num0;
	int	                    		sv_net_num1;
	int	                    		sv_node_num1;
	int	                    		sv_net_num2;
	int	                    		sv_node_num2;
	int	                    		sv_net_num3;
	int	                    		sv_node_num3;
	int	                    		sv_net_num4;
	int	                    		sv_node_num4;
	int	                    		sv_net_num5;
	int	                    		sv_node_num5;
	int	                    		sv_net_num6;
	int	                    		sv_node_num6;
	int	                    		sv_net_num7;
	int	                    		sv_node_num7;
	int	                    		sv_net_num8;
	int	                    		sv_node_num8;
	int	                    		sv_net_num9;
	int	                    		sv_node_num9;
	Ici*	                   		sv_arp_iciptr;
	ip_dgram_list*	         		sv_dgram_list_ptr;
	int	                    		sv_def_str;
	int	                    		sv_default_ttl;
	int	                    		sv_n_links;
	mc_id	                  		sv_mc_table[MAX_NO_GRPS];
	int                     		sv_print_flag;
	int                     		sv_control_pk_queue;
	int                     		sv_resv_pk_queue;
	int                     		sv_be_pk_queue;
	int                     		sv_SourceNet;
	int                     		sv_GrpId;
	} ip_gwy_state;

#define pr_state_ptr            		((ip_gwy_state*) SimI_Mod_State_Ptr)
#define server_busy             		pr_state_ptr->sv_server_busy
#define rte_tab                 		pr_state_ptr->sv_rte_tab
#define gwy_type                		pr_state_ptr->sv_gwy_type
#define Indep_Rou               		pr_state_ptr->sv_Indep_Rou
#define mc_join                 		pr_state_ptr->sv_mc_join
#define pk_sent                 		pr_state_ptr->sv_pk_sent
#define tmpPkSent               		pr_state_ptr->sv_tmpPkSent
#define sizeofpacket            		pr_state_ptr->sv_sizeofpacket
#define tmpsizeofpacket         		pr_state_ptr->sv_tmpsizeofpacket
#define service_rate            		pr_state_ptr->sv_service_rate
#define tmp_sim_time            		pr_state_ptr->sv_tmp_sim_time
#define tmp_sim_time1           		pr_state_ptr->sv_tmp_sim_time1
#define tracking_interval       		pr_state_ptr->sv_tracking_interval
#define ControlPktBitsSer       		pr_state_ptr->sv_ControlPktBitsSer
#define own_id                  		pr_state_ptr->sv_own_id
#define sub_netid               		pr_state_ptr->sv_sub_netid
#define qospf_objid             		pr_state_ptr->sv_qospf_objid
#define rsvp_objid              		pr_state_ptr->sv_rsvp_objid
#define net_num0                		pr_state_ptr->sv_net_num0
#define node_num0               		pr_state_ptr->sv_node_num0
#define net_num1                		pr_state_ptr->sv_net_num1
#define node_num1               		pr_state_ptr->sv_node_num1
#define net_num2                		pr_state_ptr->sv_net_num2
#define node_num2               		pr_state_ptr->sv_node_num2
#define net_num3                		pr_state_ptr->sv_net_num3
#define node_num3               		pr_state_ptr->sv_node_num3
#define net_num4                		pr_state_ptr->sv_net_num4
#define node_num4               		pr_state_ptr->sv_node_num4
#define net_num5                		pr_state_ptr->sv_net_num5
#define node_num5               		pr_state_ptr->sv_node_num5
#define net_num6                		pr_state_ptr->sv_net_num6
#define node_num6               		pr_state_ptr->sv_node_num6
#define net_num7                		pr_state_ptr->sv_net_num7
#define node_num7               		pr_state_ptr->sv_node_num7
#define net_num8                		pr_state_ptr->sv_net_num8
#define node_num8               		pr_state_ptr->sv_node_num8
#define net_num9                		pr_state_ptr->sv_net_num9
#define node_num9               		pr_state_ptr->sv_node_num9
#define arp_iciptr              		pr_state_ptr->sv_arp_iciptr
#define dgram_list_ptr          		pr_state_ptr->sv_dgram_list_ptr
#define def_str                 		pr_state_ptr->sv_def_str
#define default_ttl             		pr_state_ptr->sv_default_ttl
#define n_links                 		pr_state_ptr->sv_n_links
#define mc_table                		pr_state_ptr->sv_mc_table
#define print_flag              		pr_state_ptr->sv_print_flag
#define control_pk_queue        		pr_state_ptr->sv_control_pk_queue
#define resv_pk_queue           		pr_state_ptr->sv_resv_pk_queue
#define be_pk_queue             		pr_state_ptr->sv_be_pk_queue
#define SourceNet               		pr_state_ptr->sv_SourceNet
#define GrpId                   		pr_state_ptr->sv_GrpId




/* Process model interrupt handling procedure */



void
ip_gwy ()
	{
	Objid		dup_lk_id;
	double          thru, thru1, thru2, thru3, pk_svc_time;
	int             insert_ok;
	int				outstrm, mtu, frag,resp,op,UP;
	int				next_net, next_node;
	int				dest_net, dest_node,s_net,protocol;
	int				i,j,frag_accum, num_frags;
	int				frag_size, data_size, len,data_len;
	int				header_size, ttl;
	char			str0 [512], str1 [512];
	Packet			*pkptr, *ip_pkptr, *frag_ptr;
	Packet			*data_pkptr;
	
	int 			  term,join,grp_id,in_strm,join_pk;
	


	FSM_ENTER (ip_gwy)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (init) enter executives **/
		FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init")
			{
			pk_sent = 0;
			/* initially the server is idle */
			server_busy = IDLE;
			
			/* get queue module's own object id */
			own_id = op_id_self ();
			qospf_objid = op_topo_assoc( own_id, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, QOSPF_STREAM );
			/* get assigned value of server processing rate */
			op_ima_obj_attr_get (own_id, "service_rate", &service_rate);
			op_ima_obj_attr_get (own_id, "Indep_Rou", &Indep_Rou);
			
			
			/* Obtain the assigned network and node numbers. */
			/* Note that this IP model supports multiple addresses */
			/* for gateways which may be members of several networks. */
			op_ima_obj_attr_get (own_id, "net_num0", &net_num0);
			op_ima_obj_attr_get (own_id, "net_num1", &net_num1);
			op_ima_obj_attr_get (own_id, "net_num2", &net_num2);
			op_ima_obj_attr_get (own_id, "node_num0", &node_num0);
			op_ima_obj_attr_get (own_id, "node_num1", &node_num1);
			op_ima_obj_attr_get (own_id, "node_num2", &node_num2);
			op_ima_obj_attr_get (own_id, "net_num3", &net_num3);
			op_ima_obj_attr_get (own_id, "node_num3", &node_num3);
			op_ima_obj_attr_get (own_id, "net_num4", &net_num4);
			op_ima_obj_attr_get (own_id, "node_num4", &node_num4);
			op_ima_obj_attr_get (own_id, "net_num5", &net_num5);
			op_ima_obj_attr_get (own_id, "node_num5", &node_num5);
			op_ima_obj_attr_get (own_id, "net_num6", &net_num6);
			op_ima_obj_attr_get (own_id, "node_num6", &node_num6);
			op_ima_obj_attr_get (own_id, "net_num7", &net_num7);
			op_ima_obj_attr_get (own_id, "node_num7", &node_num7);
			op_ima_obj_attr_get (own_id, "net_num8", &net_num8);
			op_ima_obj_attr_get (own_id, "node_num8", &node_num8);
			op_ima_obj_attr_get (own_id, "net_num9", &net_num9);
			op_ima_obj_attr_get (own_id, "node_num9", &node_num9);
			op_ima_obj_attr_get (own_id, "DEF_STRM", &def_str);
			op_ima_obj_attr_get (own_id, "TRACK_INTVL", &tracking_interval); 
			
			
			/* Create a datagram list used to hold datagram fragments */
			/* Until complete datagrams can be reconstructed. */
			dgram_list_ptr = ip_frag_sup_setup ();
			
			
			/* Create an Ici for communicating destination addresses to arp. */
			arp_iciptr = op_ici_create ("ip_arp_req");
			
			/*
			for(i = 0; i < MAX_NO_GRPS; ++i)
			{
			  for(j = 0; j < MAX_NO_LINKS; ++j)
			    {  
					mc_table[i].interface[j]=-1;
			        mc_table[i].mtu[j] = 4096;
			    }
			} 
			*/
			
			memset( mc_table, -1, sizeof(mc_id) );
			
			if(!Indep_Rou)sub_netid = op_topo_parent(op_topo_parent(own_id));
			   else sub_netid=op_topo_parent(own_id);
			n_links = op_topo_assoc_count(sub_netid,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_LKSIMP);
			
			VL	IPVL	printf("N-links at %d = %d\n",net_num0,n_links);
			
			
			if(op_id_to_type(sub_netid) == OPC_OBJTYPE_SUBNET) gwy_type = 1;
			  else gwy_type = 0;
			
			/* for(i=0;, i< n_links ; ++i){
			    dup_lk_id = op_topo_assoc(sub_netid,OPC_TOPO_ASSOC_IN, OPC_OBJTYPE_LKDUP,i);
			    net_id = op_topo_assoc(dup_lk_id,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_SUBNET,0);
					}*/
			/*printf("N_links for %d.%d = %d\n",net_num0, node_num0,n_links);*/
			
			/*  for(i=0;i<500;++i) rte_tab[i] = -1;    */
			
			memset( rte_tab, -1, sizeof(int)*500 ); 
			
			print_flag = ON;
			
			tmp_sim_time = 0;
			tmp_sim_time1 = 0;
			sizeofpacket = 0;
			tmpsizeofpacket = 0;
			}


		/** state (init) exit executives **/
		FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init")
			{
			}


		/** state (init) transition processing **/
		FSM_INIT_COND (ARRIVAL)
		FSM_DFLT_COND
		FSM_TEST_LOGIC ("init")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (arrival) enter executives **/
		FSM_STATE_ENTER_FORCED (1, state1_enter_exec, "arrival")
			{
			/* 
			** Acquire the arriving packet. Multiple arriving streams are supported. 
			*/
			in_strm = op_intrpt_strm();
			pkptr = op_pk_get (in_strm);
			
			/* 
			** If the received packet does not have a time-to-live field assignment, place the default value 
			** in this field. In  this model, ttl is treated as a  hop allowance decremented by one prior to 
			** each  transmission. If the  decremented counter  reaches zero, the packet  is not transmitted 
			*/
			if (!op_pk_nfd_is_set (pkptr, "ttl"))
			{
				op_pk_nfd_set (pkptr, "ttl", IP_DEFAULT_TTL);
			}
			op_pk_nfd_set(pkptr,"strm",in_strm);
			
			/*
			** Each packet is enqueued at the tail of its corresponding queue. In this model to simulate the
			** resource  reservation behaviour, three  subqueues one  for control packets, one  for resource 
			** requesting traffic and the other for best effort traffic are implemented. The control packets
			** queue is given top priority, then the resource requesting traffic queue and least priority is
			** given to the best effort traffic queue
			*/
			switch( get_prio(pkptr) )
			{
				case CONTROL_PKTS :
					if( control_pk_queue <= MAX_LEN_CONTROL_BUFFER )
					{
						if( op_subq_pk_insert( get_prio(pkptr), pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK )
						{
							op_pk_destroy(pkptr);
							insert_ok = FALSE;
						}
						else
						{
							control_pk_queue++;
							insert_ok = TRUE;
						}
					}
					else
					{
						op_pk_destroy(pkptr);
						insert_ok = FALSE;
					}
				break;
				case RESV_PKTS :
					if( resv_pk_queue <= MAX_LEN_RESV_BUFFER )
					{
						if( op_subq_pk_insert( get_prio(pkptr), pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK )
						{
							op_pk_destroy(pkptr);
							insert_ok = FALSE;
						}
						else
						{
							insert_ok = TRUE;
							resv_pk_queue++;
						}
					}
					else
					{
						op_pk_destroy(pkptr);
						insert_ok = FALSE;
					}
				break;
				case BE_PKTS :
					if( be_pk_queue <= MAX_LEN_BE_BUFFER )
					{
						if( op_subq_pk_insert( get_prio(pkptr), pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK )
						{
							op_pk_destroy(pkptr);
							insert_ok = FALSE;
						}
						else
						{
							insert_ok = TRUE;
							be_pk_queue++;
						}
					}
					else
					{
						op_pk_destroy(pkptr);
						insert_ok = FALSE;
					}
				break;
				default : break;
			}
			}


		/** state (arrival) exit executives **/
		FSM_STATE_EXIT_FORCED (1, state1_exit_exec, "arrival")
			{
			}


		/** state (arrival) transition processing **/
		FSM_INIT_COND (!server_busy && insert_ok)
		FSM_DFLT_COND
		FSM_TEST_LOGIC ("arrival")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 3, state3_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (idle) enter executives **/
		FSM_STATE_ENTER_UNFORCED (2, state2_enter_exec, "idle")
			{
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (5,ip_gwy)


		/** state (idle) exit executives **/
		FSM_STATE_EXIT_UNFORCED (2, state2_exit_exec, "idle")
			{
			}


		/** state (idle) transition processing **/
		FSM_INIT_COND (ARRIVAL)
		FSM_TEST_COND (SVC_COMPLETION)
		FSM_TEST_LOGIC ("idle")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 4, state4_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (svc_start) enter executives **/
		FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "svc_start")
			{
			pk_svc_time = 1.0 / service_rate;	/* time required to complete service of the packet */
			
			/* 
			** schedule an interrupt for this process at the time where service ends. 
			*/
			op_intrpt_schedule_self (op_sim_time () + pk_svc_time, 0);
			server_busy = BUSY;
			}


		/** state (svc_start) exit executives **/
		FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "svc_start")
			{
			}


		/** state (svc_start) transition processing **/
		FSM_TRANSIT_FORCE (2, state2_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (svc_compl) enter executives **/
		FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "svc_compl")
			{
			int s_node;
			UP = 0;
			
			/* 
			** extract packet at head of queue this is the packet just finishing service 
			*/
			for(i = 0; i < 3; i++)
			{
				if(op_subq_empty(i) == OPC_FALSE)
				{
					pkptr = op_subq_pk_remove (i, OPC_QPOS_HEAD);
					switch(i)
					{
						case CONTROL_PKTS:
							control_pk_queue--;
							ControlPktBitsSer = ControlPktBitsSer + op_pk_total_size_get( pkptr );
						break;
						case RESV_PKTS:
							resv_pk_queue--;
						break;
						case BE_PKTS:
							be_pk_queue--;
						break;
						default : break;
					}
			
					break;
				}
			}
			
			pk_sent++;
			op_stat_local_write(CUMM_THRU, pk_sent);
			
			thru = pk_sent/op_sim_time();
			op_stat_local_write(THRU_OUT, thru);
			
			sizeofpacket = sizeofpacket + op_pk_total_size_get( pkptr );
			thru2 = sizeofpacket;
			op_stat_local_write(CUMM_BIT_THRU, thru2);
			
			tmpPkSent++;
			tmpsizeofpacket = tmpsizeofpacket + op_pk_total_size_get( pkptr );
			
			op_stat_local_write( Lsa_Vs_Other_Stat, ControlPktBitsSer/sizeofpacket );
			
			if( op_sim_time() > tmp_sim_time + 5*tracking_interval )
			{
				thru1 = tmpPkSent/5*tracking_interval;
				op_stat_local_write(THROUGHPUT, thru1);
				tmpPkSent = 0;
				tmp_sim_time = op_sim_time();
			
				thru3 = tmpsizeofpacket/5*tracking_interval;
				op_stat_local_write(BIT_THRU, thru3);
				tmpsizeofpacket = 0;
			}
			
			if(pkptr == OPC_NIL) 
				op_sim_end("Can't get any packet from que????","","","");
			
			
			/* 
			** An IP packet has completed service. Obtain the destination network and node numbers. 
			*/
			op_pk_nfd_get( pkptr, "dest_node", &dest_node );
			op_pk_nfd_get( pkptr, "dest_net", &dest_net );
			op_pk_nfd_get( pkptr, "src_net", &s_net );
			op_pk_nfd_get( pkptr, "src_node", &s_node );
			op_pk_nfd_get( pkptr, "prot_id",&protocol );
			op_pk_nfd_get( pkptr, "strm", &in_strm );
			SourceNet = s_net;
			GrpId = dest_node;
			
			VL IPVL 
				printf("Got the Packet Info. The Packet Dest Address is %d.%d\n", dest_net, dest_node); 
			
			if ( op_sim_time() > tmp_sim_time1 + 5*tracking_interval )
			{
				FILE* fp;
				int track_flag;
			
				printf("Current Simulation time is %f\n", op_sim_time() ); 
			
				tmp_sim_time1 = op_sim_time();
			
				fp = fopen("../LogFiles/TurnOffFile", "r" );
				if(!fp)
					op_sim_end("Unable to open the file TurnOffFile......","","","");
				fscanf( fp, "%d", &track_flag );
				fclose( fp );
				if(!track_flag)
				{
					op_sim_end("Simulation stopped by the TurnOff file......","","","");
				}
			}
			
			if( protocol == IGMP_PROTOCOL_ID ) 
			{
				UP = 0;
			}
			
			if(dest_net == IS_MULTICAST )
			{   
				/*does this include data packets*/
				UP = 1;
				if( in_strm == IGMP_STREAM || in_strm == RSVP_STREAM || in_strm == QOSPF_STREAM || 
				  ( in_strm == 0 && dest_node == IS_MULTICAST) ) 
				{
					UP = 0; 			/* then it is a query or a response from this router */
				}
				else
				{
			    	/*
					** it's either a data from outside(2), or response to my query(3), or a query from 
					** another router(4)
					*/
			     	if( protocol == UDP_PROTOCOL_ID ) 
						UP = 0;
				}
			
				/* 
				** If the packet is a multicast data packet then check if it is requesting resources or
				** not. If it is resource requesting traffic send a remote interrupt to QOSPF module to
				** do  the qospf  dijikstra's calculation. If  the packet is best effort multicast data 
				** packet send remote  interrupt to QOSPF  module for the mospf dijikstra's calculation
				*/
				if( protocol == UDP_PROTOCOL_ID )
			    {
			        int IsResvPkt;
			        IsResvPkt = CheckIfResvPkt( s_net, s_node, dest_net, dest_node );
			        if( IsResvPkt == 0 )
					{
			            op_intrpt_schedule_remote( op_sim_time(), 7, qospf_objid );
					}
			        if( IsResvPkt == 1 )
					{
			            op_intrpt_schedule_remote( op_sim_time(), 8, qospf_objid );
					}
			    }
			}
			if( protocol == QOSPF_PROTOCOL_ID && in_strm != QOSPF_STREAM )
			{
				VL IPVL printf( "Obtained a QOSPF Packet from the source %d through the stream %d\n",
						 s_net, in_strm );
				UP = 1;
			}
			if( protocol == RSVP_PROTOCOL_ID && in_strm !=RSVP_STREAM ) 
			{
				VL IPVL printf("IP LAYER(%d.%d): Obtained a packet from source %d.%d through stream %d\n", 
					net_num0, node_num0, s_net, s_node, in_strm );
				UP = 1;
			}
			
			/*
			** If there is no default route and no route to this packet and the packet neither a multicast
			** nor a OSPF control packet, then destroy the packet
			*/
			if( rte_tab[dest_net] == -1 && rte_tab[DEF_STREAM] == -1 && dest_net != IS_MULTICAST && 
			    (dest_net !=ALL_SPF_ROUTER_NET && dest_node !=ALL_SPF_ROUTER_NODE) &&
				(dest_net !=ALL_D_ROUTER_NET && dest_node !=4) )
			{
				printf( "(%d.%d) Destroying pk destinated to %d b'cos no route in svc_compl\n", 
						net_num0, node_num0, dest_net );
				op_pk_destroy( pkptr );
			}
			else
			{
				/* 
				** In the case of packets which have reached their destination, reassembly the ip fragments 
				*/
				if( (dest_net == net_num0 && dest_node == node_num0) ||
					(dest_net == net_num1 && dest_node == node_num1) ||
					(dest_net == net_num2 && dest_node == node_num2) ||
					(dest_net == net_num3 && dest_node == node_num3) ||
					(dest_net == net_num4 && dest_node == node_num4) || UP )
				{
					/* 
					** Call the fragment reassembly procedure to determine if a complete packet has arrived. 
					** Note that the packet will be destroyed in this procedure call unless it is itself the 
					** complete datagram (i.e., it isn't a fragment) 
					*/
					if( (ip_pkptr = ip_frag_sup_insert (dgram_list_ptr, pkptr)) != OPC_NIL )
					{
						if( protocol == IGMP_PROTOCOL_ID )
							outstrm= IGMP_STREAM;
						if( protocol == QOSPF_PROTOCOL_ID )
							outstrm = QOSPF_STREAM;         
						if( protocol == TCP_PROTOCOL_ID ) 
							outstrm = TCP_STREAM;
						if( protocol == RSVP_PROTOCOL_ID )
							outstrm = RSVP_STREAM;
			
						op_pk_send( ip_pkptr, outstrm ); /* Forward the complete packet to the higher layer. */
					}
				}
			
				/* 
				** For packets which have not reached their ultimate destination, they are forwarded to next hop. 
				*/
				else
				{   
					/* 
					** Decrement the packet's time-to-live field. If zero is reached, destroy the packet 
					*/
					op_pk_nfd_get( pkptr, "ttl", &ttl );
					ttl--;
					if( ttl == 0  && dest_net == IS_MULTICAST )
					{
						op_pk_destroy (pkptr); 			/* due to an expired ttl. */
					}
					else
					{
						/* 
						** 
						*/
						op_pk_nfd_set (pkptr, "ttl", ttl);       /*Assign the new decremented value of ttl.  */
			
						if( dest_net != IS_MULTICAST && 
							(dest_net!=ALL_SPF_ROUTER_NET && dest_node!=ALL_SPF_ROUTER_NODE) 
							|| protocol == RSVP_PROTOCOL_ID )
						{             
							if( protocol == RSVP_PROTOCOL_ID )
							{
								op_pk_nfd_get( pkptr, "outstrm", &outstrm );
			
								if( outstrm == -1 && Indep_Rou)
										outstrm++;
								else if( outstrm == -1 )
									outstrm = rte_tab[dest_net];
			
								VL IPVL printf("IP LAYER(%d.%d): Processing RSVP Packets, OUT STREAM is %d\n", 
										   net_num0, node_num0, outstrm );
							}
							else 
								outstrm = rte_tab[dest_net];
			
							if(outstrm == -1)
								outstrm = rte_tab[DEF_STREAM];
			
							mtu = 4096;
			
							/* 
							** Install an Ici indicating to the lower layer what the address of the next 
							** (intermediate) node is. 
							*/
							if(dest_net == 500)
								next_node = dest_net + dest_node;
							else
								next_node = dest_node;
							op_ici_attr_set( arp_iciptr, "next_node", next_node );
							op_ici_install( arp_iciptr );
							
							frag_size = op_pk_total_size_get( pkptr )/8;    /* size of the fragment in bytes       */
							op_pk_nfd_get( pkptr, "frag_len", &data_size ); /* Size of the data in fragment(bytes) */
							header_size = frag_size - data_size; /* Size of header(Diff btn. packet size & length) */
			
							/* 
							** If it is smaller than the maximum transfer unit, send it as is. 
							*/
							if( frag_size <= mtu )
							{
								op_pk_send( pkptr, outstrm );
							}
							else
							{			
								/* 
								** Otherwise, break it into fragments. Each fragment can contain up to 
								** (mtu - header_size) bytes of data 
								*/
								num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);
			
								/* In debug mode, indicate the fragmentation. */
								if( op_prg_odb_ltrace_active ("ip_frag") )
								{
									sprintf( str0, "Breaking datagram into (%d) fragments", num_frags );
									op_prg_odb_print_major( str0, OPC_NIL );
								}
			
								/* 
								** If the fragment is carrying the original datagram given to IP, extract it 
								** before  copies are made. Only one fragment  can carry the original packet 
								** for the reassembly model to work properly. 
								*/
								if( op_pk_nfd_is_set (pkptr, "ip_dgram") )
									op_pk_nfd_get( pkptr, "ip_dgram", &ip_pkptr );
								else 
									ip_pkptr = OPC_NIL;
			
								/* 
								** If the packet is carrying any encapsulated data (normally this would happen 
								** only for a packet fragmented for  the first time), extract this data packet 
								** so that it will not appear in each fragment generated by copying. 
								*/
								if( op_pk_nfd_is_set( pkptr, "data" ) )
									op_pk_nfd_get( pkptr, "data", &data_pkptr );
								else data_pkptr = OPC_NIL;
			
								for( frag_accum = 0, i = 0; i < num_frags; i++ )   /* create the fragments.       */
								{
									frag_ptr = op_pk_copy( pkptr );       /* Make a copy of the original packet.  */
									op_pk_nfd_set( frag_ptr, "frag", 1 ); /* Indicate that the copy is a fragment */
			
									/* 
									** for all but the last fragment, the size is the mtu. And the encapsulated 
									** ip packet is not included. 
									*/
									if( i < num_frags - 1 )
									{
										op_pk_nfd_set( frag_ptr, "frag_len", mtu - header_size );
										op_pk_total_size_set( frag_ptr, 8 * mtu );
										frag_accum += (mtu - header_size);  
									}
									else
									{
										len = data_size - frag_accum;
										op_pk_nfd_set( frag_ptr, "frag_len", len );
										op_pk_total_size_set( frag_ptr,	8 * (header_size + len) );
			
										/* 
										** If the original packet was not a fragment, encapsulate it into the last 
										** fragment created here. 
										*/
										op_pk_nfd_get( pkptr, "frag", &frag );
										if( !frag )
										{
											/* 
											** If the packet  contained encapsulated data (i.e., from the transport), 
											** that  data will  have been  removed  to avoid it's  duplication in the 
											** fragments. The data  should now be reinserted into the original packet 
											*/
											if( data_pkptr != OPC_NIL )
												op_pk_nfd_set( pkptr, "data", data_pkptr );
			
											/* In either case the original packet is encapsulated in the fragment. */
											op_pk_nfd_set( frag_ptr, "ip_dgram", pkptr ); 
										}
										else
										{
											op_pk_destroy (pkptr);
			
											/* 
											** Also, if  the packet includes the  original datagram from which it was 
											** generated, transfer that datagram into the last fragment created here. 
											** Note that it is possible, in the case where a fragment is itself being 
											** fragmented, none  of the created  fragments will  contain the original 
											** datagram. 
											*/
											if( ip_pkptr != OPC_NIL )
												op_pk_nfd_set (frag_ptr, "ip_dgram", ip_pkptr);
										}
									}
									op_pk_send (frag_ptr, outstrm);			/* Forward the datagram fragment. */
								}	
							}
						}  
						else
						{
							if(gwy_type)
							{
								VL IPVL	printf("Gwy_type is %d\n, and In Stream is %d, NoOfLinks are %d\n", 
											gwy_type, in_strm, n_links );
								if( (in_strm == 0 && protocol == UDP_PROTOCOL_ID)|| protocol == QOSPF_PROTOCOL_ID
									|| protocol == RSVP_PROTOCOL_ID )
									op = 1;
								else 
									op = 0;
							}
							else
								op = 1;
			
							VL IPVL printf("IP LAYER, op = %d", op );
							VL	IPVL
							{
								int i, j;
								printf(" %d.%d IP Layer MC_TABLE : \n", net_num0, node_num0 );
								printf(" - - - - - - - - - - - - - \n");
								for ( i = 0; i < MAX_NO_GRPS; i++ )
									for(j = 0; j <= n_links; j++ )
										if( mc_table[i].interface[j] == 1 )
											printf(" Interface %d is registered for the Group %d \n", j, i );
							}
			
							if( (dest_net == IS_MULTICAST || 
								(dest_net == ALL_SPF_ROUTER_NET && dest_node == ALL_SPF_ROUTER_NODE)) &&
								protocol != RSVP_PROTOCOL_ID )
							{  
								ip_pkptr = op_pk_copy(pkptr);   
								op_pk_destroy(pkptr);
								while( op < n_links+1 )
								{ 
									/*
									if(dest_node != 500)
									{
										VL IPVL printf("link[%d] = %d\n",op,mc_table[dest_node].interface[op]);
										getchar();
									}
									*/
									if( (mc_table[dest_node].interface[op] == 1 || dest_net == IS_MULTICAST) || 
										( (dest_net == ALL_SPF_ROUTER_NET && dest_node == ALL_SPF_ROUTER_NODE) && 
										(op != in_strm)) )
									{      
										mtu = 4096; 
										VL IPVL printf("Sending on link : %d at (%d.%d)\n",op,net_num0,node_num0);
			
										pkptr = op_pk_copy(ip_pkptr);
										if(op == 0) 
										/*means it's going to ethernet*/
										{  
											next_node = 500+dest_node;
											op_ici_attr_set(arp_iciptr,"next_node",next_node);
											op_ici_install(arp_iciptr);
										}
			
										/*
										** sending the pk
										*/
										frag_size = op_pk_total_size_get (pkptr) / 8; /* Size of fragment in bytes */
										op_pk_nfd_get( pkptr, "frag_len", &data_size ); /* Size of data in bytes   */
										header_size = frag_size - data_size; 			/* Header size in bytes    */
			
										/* 
										** If fragment is  smaller than the maximum transfer unit, send it as is. 
										*/
										if (frag_size <= mtu)
										{ 
											op_pk_send( pkptr, op );
										}
										else
										{			
											/* 
											** Otherwise, break it into fragments. Each fragment can contain up to 
											** (mtu - header_size) bytes of data 
											*/
											num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);
			
											/* In debug mode, indicate the fragmentation. */
											if( op_prg_odb_ltrace_active ("ip_frag") )
											{
												sprintf( str0, "Breaking datagram into (%d) fragments", num_frags );
												op_prg_odb_print_major( str0, OPC_NIL );
											}
			
											/* 
											** If the fragment is carrying the original datagram given to IP, extract 
											** it  before copies are made. Only  one fragment can  carry the original 
											** packet for the reassembly model to work properly. 
											*/
											if( op_pk_nfd_is_set (pkptr, "ip_dgram") )
												op_pk_nfd_get( pkptr, "ip_dgram", &ip_pkptr );
											else 
												ip_pkptr = OPC_NIL;
			
											/* 
											** If the packet is carrying encapsulated data (normally this would happen 
											** only  for a packet  fragmented for the first time ), extract  this data 
											** packet so that it will not appear in each fragment generated by copying. 
											*/
											if( op_pk_nfd_is_set( pkptr, "data" ) )
												op_pk_nfd_get (pkptr, "data", &data_pkptr);
											else 
												data_pkptr = OPC_NIL;
			
											for( frag_accum = 0, i = 0; i < num_frags; i++ ) /* Create the fragments */
											{
												frag_ptr = op_pk_copy (pkptr);  /* Copy the original packet          */
												op_pk_nfd_set (frag_ptr, "frag", 1); /* Indicate that it is fragment */
			
												/* 
												** for all but the last fragment, the size is the mtu. And the 
												** encapsulated ip packet is not included. 
												*/
												if( i < num_frags - 1 )
												{
													op_pk_nfd_set( frag_ptr, "frag_len", mtu - header_size );
													op_pk_total_size_set( frag_ptr, 8 * mtu );
													frag_accum += (mtu - header_size);  
												}
												else
												{
													len = data_size - frag_accum;
													op_pk_nfd_set( frag_ptr, "frag_len", len );
													op_pk_total_size_set( frag_ptr,	8 * (header_size + len) );
													/* 
													** If the original packet was not a fragment, encapsulate it 
													** into the last fragment created here. 
													*/
													op_pk_nfd_get( pkptr, "frag", &frag );
													if( !frag )
													{
														/* 
														** If the packet contained encapsulated data(i.e., from the 
														** transport ), that data  will have been  removed to avoid 
														** its duplication in the fragments. The data should now be 
														** reinserted into the original packet. 
														*/
														if( data_pkptr != OPC_NIL )
															op_pk_nfd_set( pkptr, "data", data_pkptr );
			
														/* 
														** In either case the original packet is encapsulated in the 
														** fragment. 
														*/
														op_pk_nfd_set( frag_ptr, "ip_dgram", pkptr );
													}
			
													/* 
													** Otherwise the packet can be discarded. 
													*/
													else
													{
														op_pk_destroy( pkptr );
			
														/* 
														** Also, if  the packet includes  the  original  datagram from 
														** which it was  generated, transfer  that datagram  into  the 
														** last  fragment created  here. Note that  it is possible, in 
														** the case where a fragment is  itself being fragmented, none 
														** of the created fragments will contain the original datagram
														*/
														if( ip_pkptr != OPC_NIL )
															op_pk_nfd_set (frag_ptr, "ip_dgram", ip_pkptr);
													}
												}
			
												op_pk_send( frag_ptr, op );     /* Forward the datagram fragment. */
											}	
										}
									}
									op++;
								}
								op_pk_destroy(ip_pkptr);
							}
						}
					}
				}
			}
			server_busy = IDLE;                                 /* The IP routing server becomes available again. */
			}


		/** state (svc_compl) exit executives **/
		FSM_STATE_EXIT_FORCED (4, state4_exit_exec, "svc_compl")
			{
			
			}


		/** state (svc_compl) transition processing **/
		FSM_INIT_COND (!QUEUE_EMPTY)
		FSM_DFLT_COND
		FSM_TEST_LOGIC ("svc_compl")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 3, state3_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (0,ip_gwy)
	}




void
ip_gwy_svar (prs_ptr,var_name,var_p_ptr)
	ip_gwy_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (ip_gwy_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;
	if (Vos_String_Equal ("server_busy" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_server_busy);
	if (Vos_String_Equal ("rte_tab" , var_name))
		*var_p_ptr = (char *) (prs_ptr->sv_rte_tab);
	if (Vos_String_Equal ("gwy_type" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_gwy_type);
	if (Vos_String_Equal ("Indep_Rou" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_Indep_Rou);
	if (Vos_String_Equal ("mc_join" , var_name))
		*var_p_ptr = (char *) (prs_ptr->sv_mc_join);
	if (Vos_String_Equal ("pk_sent" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_pk_sent);
	if (Vos_String_Equal ("tmpPkSent" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tmpPkSent);
	if (Vos_String_Equal ("sizeofpacket" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sizeofpacket);
	if (Vos_String_Equal ("tmpsizeofpacket" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tmpsizeofpacket);
	if (Vos_String_Equal ("service_rate" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_service_rate);
	if (Vos_String_Equal ("tmp_sim_time" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tmp_sim_time);
	if (Vos_String_Equal ("tmp_sim_time1" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tmp_sim_time1);
	if (Vos_String_Equal ("tracking_interval" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tracking_interval);
	if (Vos_String_Equal ("ControlPktBitsSer" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_ControlPktBitsSer);
	if (Vos_String_Equal ("own_id" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_own_id);
	if (Vos_String_Equal ("sub_netid" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sub_netid);
	if (Vos_String_Equal ("qospf_objid" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_qospf_objid);
	if (Vos_String_Equal ("rsvp_objid" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_rsvp_objid);
	if (Vos_String_Equal ("net_num0" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num0);
	if (Vos_String_Equal ("node_num0" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num0);
	if (Vos_String_Equal ("net_num1" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num1);
	if (Vos_String_Equal ("node_num1" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num1);
	if (Vos_String_Equal ("net_num2" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num2);
	if (Vos_String_Equal ("node_num2" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num2);
	if (Vos_String_Equal ("net_num3" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num3);
	if (Vos_String_Equal ("node_num3" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num3);
	if (Vos_String_Equal ("net_num4" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num4);
	if (Vos_String_Equal ("node_num4" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num4);
	if (Vos_String_Equal ("net_num5" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num5);
	if (Vos_String_Equal ("node_num5" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num5);
	if (Vos_String_Equal ("net_num6" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num6);
	if (Vos_String_Equal ("node_num6" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num6);
	if (Vos_String_Equal ("net_num7" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num7);
	if (Vos_String_Equal ("node_num7" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num7);
	if (Vos_String_Equal ("net_num8" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num8);
	if (Vos_String_Equal ("node_num8" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num8);
	if (Vos_String_Equal ("net_num9" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_num9);
	if (Vos_String_Equal ("node_num9" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_num9);
	if (Vos_String_Equal ("arp_iciptr" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_arp_iciptr);
	if (Vos_String_Equal ("dgram_list_ptr" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_dgram_list_ptr);
	if (Vos_String_Equal ("def_str" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_def_str);
	if (Vos_String_Equal ("default_ttl" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_default_ttl);
	if (Vos_String_Equal ("n_links" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_n_links);
	if (Vos_String_Equal ("mc_table" , var_name))
		*var_p_ptr = (char *) (prs_ptr->sv_mc_table);
	if (Vos_String_Equal ("print_flag" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_print_flag);
	if (Vos_String_Equal ("control_pk_queue" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_control_pk_queue);
	if (Vos_String_Equal ("resv_pk_queue" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_resv_pk_queue);
	if (Vos_String_Equal ("be_pk_queue" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_be_pk_queue);
	if (Vos_String_Equal ("SourceNet" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_SourceNet);
	if (Vos_String_Equal ("GrpId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_GrpId);

	FOUT;
	}




void
ip_gwy_diag ()
	{
	Objid		dup_lk_id;
	double          thru, thru1, thru2, thru3, pk_svc_time;
	int             insert_ok;
	int				outstrm, mtu, frag,resp,op,UP;
	int				next_net, next_node;
	int				dest_net, dest_node,s_net,protocol;
	int				i,j,frag_accum, num_frags;
	int				frag_size, data_size, len,data_len;
	int				header_size, ttl;
	char			str0 [512], str1 [512];
	Packet			*pkptr, *ip_pkptr, *frag_ptr;
	Packet			*data_pkptr;
	
	int 			  term,join,grp_id,in_strm,join_pk;
	

	FIN (ip_gwy_diag ())

	op_prg_odb_print_major ("State of Reassembly Table:", OPC_NIL);
	ip_frag_sup_print (dgram_list_ptr);
	

	FOUT;
	}




void
ip_gwy_terminate ()
	{
	Objid		dup_lk_id;
	double          thru, thru1, thru2, thru3, pk_svc_time;
	int             insert_ok;
	int				outstrm, mtu, frag,resp,op,UP;
	int				next_net, next_node;
	int				dest_net, dest_node,s_net,protocol;
	int				i,j,frag_accum, num_frags;
	int				frag_size, data_size, len,data_len;
	int				header_size, ttl;
	char			str0 [512], str1 [512];
	Packet			*pkptr, *ip_pkptr, *frag_ptr;
	Packet			*data_pkptr;
	
	int 			  term,join,grp_id,in_strm,join_pk;
	

	FIN (ip_gwy_terminate ())


	FOUT;
	}



Compcode
ip_gwy_init (pr_state_pptr)
	ip_gwy_state			**pr_state_pptr;
	{
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (ip_gwy_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (ip_gwy)",
			sizeof (ip_gwy_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (ip_gwy_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 0;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



	int  get_prio(kpt)
		Packet* kpt;
	{
		int pro;
		op_pk_nfd_get(kpt,"prot_id",&pro);
		switch(pro) 
		{
			case 89: pro = 0;
				 break;
			case 46: pro = 0;
				 break;
			case 20: pro = 1;
				 break;
			case 9: pro = 1;
				 break;
			case 12: pro = 2;
				 break;
			default:  op_sim_end("Whaaaat pk is this?","","","");
		}
		return(pro);
	}
	
	int CheckIfResvPkt( int s_net, int s_node, int dest_net, int dest_node )
	{
	    /*  sd *tsd;  */
	    /*  tsd = (sd*) op_ima_obj_svar_get( rsvp_objid, "SessDirectory" );  */
	    /*  if( tsd[dest_node].SenderAddr.NetNum == s_net &&  */
	        /*  tsd[dest_node].SenderAddr.NodeNum == s_node )  */
		if( dest_node > 10 && dest_node <= 30 )
	    {
	        return 1;
	    }
	    else
	        return 0;
	}
